//#################### Vertex Time & Momentum Reconstruction #####################
//Magnetic field density in [T] ---0.693---0.84--------------------------------------------
double magnetic_field_density = 0.92;//0.92;

//Distance from target to collimator [mm] --------------------------------
double DistanceToCollimator = 1267.03;

//Distance from target to front face of BB magnet in [mm] --------------------------------
double dist_to_target = 1267.0 + 350.0; //1267.0 + 350.0;

//Position of exit face with respect to to front face of BB magnet in [mm] 1.0-------------
double exit_face_xc = 800.0;
double exit_face_yc = 0.0; //10.0


//Length and Height of BB magnet in [mm] 753-- 818----------------------------------------
double magnet_length = 1000.1;
double magnet_height = 1200.0;

//Exit face angle in [deg] -------------------------------------------------------
double exit_face_angle = 20.0;

//Multi Wire Drift Chamber angle in [deg] ----------------------------------------
double MWDC_angle = 25.0;

//Position of First MWDC plane with respect to the entrance face in [mm] 1100 in 320---------------------
double MWDC_x = 1100.0 + 150.0; // 
double MWDC_y = 300.0  + 150.0*tan(25.0*3.1415/180);

//Distance from first MWDC plane fo second MWDC plane in [mm] --------------------
double MWDC_dist_to_second = 757.0;

//Scattering angle  [rad] --------------------
double scattering_angle = -75.0 * 3.1415/180.0;

//Distance from first MWDC plane to Scintillation plane in [mm] ------------------
double distance_to_EdE  = 973.0;
//################################################################################