function opticPhSVD()
  disp('Hello');
  
  DistanceToCollimator = 1.26703; 
  
  global data;
  
  loadData();
  disp('Data size:');
  disp(size(data,1));  
  
  Num=size(data,1); % number of datapoints
  M = 68; % number of parameters
  %mm = 68; % considered matrix elements
 
  chi2vec=[];
  
  %for mm = 1:M
  for mm = 40:40
     
    AMat=[];
    bVec=[];
    for i=1:Num;
    
      x=data(i,1);
      y=data(i,2);
      th=data(i,3); 
      ph=data(i,4);
      tgy=data(i,5);
      rby = data(i,6);
      rbz = data(i,7);
  
      yC = data(i,8);
      rC = 0.00952;
      

      AMat= [AMat;[ 1, ph, ph^2, ph^3, ph^4, ph*th, ph^2*th, ph^3*th, ...
          ph*th^2, x, ph*x, ph^2*x, ph^3*x, th*x, ph*th*x, ph^2*th*x, ...
          th^2*x, ph*th^2*x, x^2, ph*x^2, ph^2*x^2, th*x^2, ph*th*x^2, ...
          th^2*x^2, x^3, ph*x^3, th*x^3, ph*y, ph^2*y, ph^3*y, th*y, ...
          ph*th*y, ph^2*th*y, th^2*y, ph*th^2*y, x*y, ph*x*y, ph^2*x*y, ...
          th*x*y, ph*th*x*y, th^2*x*y, x^2*y, ph*x^2*y, th*x^2*y, x^3*y, ...
          y^2, ph*y^2, ph^2*y^2, ph*th*y^2, th^2*y^2, x*y^2, ph*x*y^2, ...
          x^2*y^2, y^3, ph*y^3, th*y^3, x*y^3, y^4, ph^3*th*x, ...
          ph^3*th*x^2, ph*th^2*x^2, ph*th*x^3, ph*th^2*x^3, ph*x^4, ...
          ph*th*x^4, ph*x^5, x^3*y^2, x^4*y^2 ]];
      
      
        
      bVec = [bVec; atan2((yC - rby),(DistanceToCollimator - rbz))];   

    
    end
  
    aVec = zeros(M,1);
    sigmaSq = zeros(M,1);
  
    [U,S,V] = svd(AMat);
    for k = 1:mm
      aVec = aVec + transpose(U(:,k))*bVec/S(k,k)*V(:,k);
    end    
   
    ExportParameters(aVec);

 
  
  
    disp('Chi2');
    chi2=transpose(AMat*aVec - bVec)*(AMat*aVec - bVec);
    disp([mm,chi2]);
    chi2vec = [chi2vec; chi2];
  
    Cov = zeros(M,M);
    for j=1:M
      for k =1:M
        elementCov = 0;
        for i = 1:mm
          elementCov = elementCov + V(k,i)*V(j,i)/S(i,i)/S(i,i);
        end
        Cov(j,k) = elementCov;
      end
    end
    
    sigmaVec = zeros(M,1);
    SingularValues = zeros(M,1);
    for j = 1:M
        sigmaVec(j) = sqrt(Cov(j,j));
        SingularValues(j) = S(j,j);
    end
    
    
    disp([aVec, sigmaVec, sigmaVec./abs(aVec)]);
    
    Corr = zeros(M,M);
    for j=1:M
      for k =1:M
        Corr(j,k) = Cov(j,k)/sqrt(Cov(j,j)*Cov(k,k));
      end
    end
    
    dlmwrite('TgPhSVDCorr.dat',Corr, ' ');
    
  end
  
  disp('Chi2 vector');
  disp(chi2vec);
  plot(chi2vec,'');
  disp('SingularValues:');
  disp(SingularValues);
  
  CalculateLimits(aVec);
  
  disp('The End!');
  
  
end







function loadData()

  num = 150;

  global data;
  
  
 
  data0a = load('outfile_3491_m5B.dat');
  data1a = load('outfile_3491_m4A.dat');
  data2a = load('outfile_3491_m4B.dat');
  data3a = load('outfile_3491_m4C.dat');
  data4a = load('outfile_3491_m4D.dat');
  data5a = load('outfile_3491_m4E.dat');
  data6a = load('outfile_3491_m4F.dat');
  data7a = load('outfile_3491_m3A.dat');
  data8a = load('outfile_3491_m3D.dat');
  data9a = load('outfile_3491_m2A.dat');
  data10a = load('outfile_3491_m2B.dat');
  
  
  data11a = load('outfile_3491_m2C.dat');
  data12a = load('outfile_3491_m2D.dat');
  data13a = load('outfile_3491_m2E.dat');
  data14a = load('outfile_3491_m2F.dat');
  data15a = load('outfile_3491_m1A.dat');
  data16a = load('outfile_3491_m1B.dat');
  data17a = load('outfile_3491_m1C.dat');
  data18a = load('outfile_3491_m1D.dat');
  data19a = load('outfile_3491_m1E.dat');
  data20a = load('outfile_3491_m1F.dat');
  
  data21a = load('outfile_3491_p0A.dat');
  data22a = load('outfile_3491_p0B.dat');
  data23a = load('outfile_3491_p0C.dat');
  data24a = load('outfile_3491_p0D.dat');
  data25a = load('outfile_3491_p0E.dat');
  data26a = load('outfile_3491_p0F.dat');
  data27a = load('outfile_3491_p1A.dat');
  data28a = load('outfile_3491_p1B.dat');
  data29a = load('outfile_3491_p1C.dat');
  data30a = load('outfile_3491_p1D.dat');
  
  data31a = load('outfile_3491_p1E.dat');
  data32a = load('outfile_3491_p1F.dat');
  data33a = load('outfile_3491_p2A.dat');
  data34a = load('outfile_3491_p2B.dat');
  data35a = load('outfile_3491_p2C.dat');
  data36a = load('outfile_3491_p2D.dat');
  data37a = load('outfile_3491_p2E.dat');
  data38a = load('outfile_3491_p2F.dat');
  data39a = load('outfile_3491_p3B.dat');
  data40a = load('outfile_3491_p3F.dat');
  
  data41a = load('outfile_3491_p4B.dat');
  data42a = load('outfile_3491_p4C.dat');
  data43a = load('outfile_3491_p4D.dat');
  data44a = load('outfile_3491_p4E.dat');
  data45a = [ load('outfile_3491_p4F.dat'); load('outfile_3491_p4F.dat');];
  data46a = load('outfile_3491_p5C.dat');
  data47a = load('outfile_3491_p5D.dat');
  data48a = load('outfile_3491_p5EF.dat');
  data49a = [load('outfile_3491_m5A.dat'); load('outfile_3491_m5A.dat');load('outfile_3491_m5A.dat');load('outfile_3491_m5A.dat');];
  data50a = load('outfile_3491_m5C.dat');  
  data51a = load('outfile_3491_m5D.dat');
  data52a = load('outfile_3491_m5E.dat');
  data53a = [load('outfile_3491_m5F.dat'); load('outfile_3491_m5F.dat'); load('outfile_3491_m5F.dat');];
  data54a = load('outfile_3491_p3A.dat');
  data55a = load('outfile_3491_p4A.dat');
  data56a = load('outfile_3491_p6A.dat');
  data57a = [load('outfile_3491_p6B.dat');  load('outfile_3491_p6B.dat');load('outfile_3491_p6B.dat');load('outfile_3491_p6B.dat');];
  data58a = [ load('outfile_3491_p6C.dat'); load('outfile_3491_p6C.dat');];
  data59a = [load('outfile_3491_p6D.dat');  load('outfile_3491_p6D.dat'); ];
  data60a = load('outfile_3491_p6E.dat');
  data61a = load('outfile_3491_p6F.dat');  
  data62a = load('outfile_3491_p6G.dat');
  data63a = load('outfile_3491_p5A.dat');
  data64a = load('outfile_3491_p5B.dat');  
  data65a = load('outfile_3491_m6B.dat');
  data66a = [load('outfile_3491_m6C.dat');load('outfile_3491_m6C.dat');];
  data67a = load('outfile_3491_m6D.dat');
  data68a = load('outfile_3491_m6E.dat');
  data69a = load('outfile_3491_m6F.dat');
  data70a = load('outfile_3491_m6A.dat');
  
  
  data4b=[data4a, 0.0*0.03810*ones(size(data4a,1),1)];  
  data8b=[data8a, 0.0*0.03810*ones(size(data8a,1),1)];  
  data12b=[data12a, 0.0*0.03810*ones(size(data12a,1),1)];  
  data18b=[data18a, 0.0*0.03810*ones(size(data18a,1),1)];  
  data24b=[data24a, 0.0*0.03810*ones(size(data24a,1),1)];  
  data30b=[data30a, 0.0*0.03810*ones(size(data30a,1),1)];  
  data36b=[data36a, 0.0*0.03810*ones(size(data36a,1),1)];  
  data43b=[data43a, 0.0*0.03810*ones(size(data43a,1),1)];  
  data47b=[data47a, 0.0*0.03810*ones(size(data47a,1),1)];  
  data51b=[data51a, 0.0*0.03810*ones(size(data51a,1),1)];
  data59b=[data59a, 0.0*0.03810*ones(size(data59a,1),1)];
  data67b=[data67a, 0.0*0.03810*ones(size(data67a,1),1)];  
  
  
  data3b=[data3a, -1.0*0.03810*ones(size(data3a,1),1)];
  data11b=[data11a, -1.0*0.03810*ones(size(data11a,1),1)];
  data17b=[data17a, -1.0*0.03810*ones(size(data17a,1),1)];
  data23b=[data23a, -1.0*0.03810*ones(size(data23a,1),1)];
  data29b=[data29a, -1.0*0.03810*ones(size(data29a,1),1)];
  data35b=[data35a, -1.0*0.03810*ones(size(data35a,1),1)];
  data42b=[data42a, -1.0*0.03810*ones(size(data42a,1),1)];
  data46b=[data46a, -1.0*0.03810*ones(size(data46a,1),1)];
  data50b=[data50a, -1.0*0.03810*ones(size(data50a,1),1)];  
  data58b=[data58a, -1.0*0.03810*ones(size(data58a,1),1)];
  data66b=[data66a, -1.0*0.03810*ones(size(data66a,1),1)];      
    
  data5b=[data5a, 1.0*0.03810*ones(size(data5a,1),1)];
  data13b=[data13a, 1.0*0.03810*ones(size(data13a,1),1)];
  data19b=[data19a, 1.0*0.03810*ones(size(data19a,1),1)];
  data25b=[data25a, 1.0*0.03810*ones(size(data25a,1),1)];
  data31b=[data31a, 1.0*0.03810*ones(size(data31a,1),1)];
  data37b=[data37a, 1.0*0.03810*ones(size(data37a,1),1)];
  data44b=[data44a, 1.0*0.03810*ones(size(data44a,1),1)];
  data52b=[data52a, 1.0*0.03810*ones(size(data52a,1),1)];    
  data60b=[data60a, 1.0*0.03810*ones(size(data60a,1),1)];
  data68b=[data68a, 1.0*0.03810*ones(size(data68a,1),1)];  
  
      
  data0b=[data0a, -2.0*0.03810*ones(size(data0a,1),1)];
  data2b=[data2a, -2.0*0.03810*ones(size(data2a,1),1)];
  data10b=[data10a, -2.0*0.03810*ones(size(data10a,1),1)];
  data16b=[data16a, -2.0*0.03810*ones(size(data16a,1),1)];
  data22b=[data22a, -2.0*0.03810*ones(size(data22a,1),1)];
  data28b=[data28a, -2.0*0.03810*ones(size(data28a,1),1)];
  data34b=[data34a, -2.0*0.03810*ones(size(data34a,1),1)];
  data39b=[data39a, -2.0*0.03810*ones(size(data39a,1),1)];
  data41b=[data41a, -2.0*0.03810*ones(size(data41a,1),1)];
  data57b=[data57a, -2.0*0.03810*ones(size(data57a,1),1)];
  data64b=[data64a, -2.0*0.03810*ones(size(data64a,1),1)];
  data65b=[data65a, -2.0*0.03810*ones(size(data65a,1),1)];    
  
  data6b=[data6a, 2.0*0.03810*ones(size(data6a,1),1)];
  data14b=[data14a, 2.0*0.03810*ones(size(data14a,1),1)];
  data20b=[data20a, 2.0*0.03810*ones(size(data20a,1),1)];
  data26b=[data26a, 2.0*0.03810*ones(size(data26a,1),1)];
  data32b=[data32a, 2.0*0.03810*ones(size(data32a,1),1)];
  data38b=[data38a, 2.0*0.03810*ones(size(data38a,1),1)];
  data40b=[data40a, 2.0*0.03810*ones(size(data40a,1),1)];
  data45b=[data45a, 2.0*0.03810*ones(size(data45a,1),1)];
  data53b=[data53a, 2.0*0.03810*ones(size(data53a,1),1)];
  data61b=[data61a, 2.0*0.03810*ones(size(data61a,1),1)];
  
  data1b=[data1a, -3.0*0.03810*ones(size(data1a,1),1)];  
  data7b=[data7a, -3.0*0.03810*ones(size(data7a,1),1)];  
  data9b=[data9a, -3.0*0.03810*ones(size(data9a,1),1)];  
  data15b=[data15a, -3.0*0.03810*ones(size(data15a,1),1)];  
  data21b=[data21a, -3.0*0.03810*ones(size(data21a,1),1)];  
  data27b=[data27a, -3.0*0.03810*ones(size(data27a,1),1)];  
  data33b=[data33a, -3.0*0.03810*ones(size(data33a,1),1)];  
  data49b=[data49a, -3.0*0.03810*ones(size(data49a,1),1)];  
  data54b=[data54a, -3.0*0.03810*ones(size(data54a,1),1)];  
  data55b=[data55a, -3.0*0.03810*ones(size(data55a,1),1)];  
  data56b=[data56a, -3.0*0.03810*ones(size(data56a,1),1)];  
  data63b=[data63a, -3.0*0.03810*ones(size(data63a,1),1)];  
  
  
  data0 = data0b(1:num, :);
  data1 = data1b(1:num, :);
  data2 = data2b(1:num, :);
  data3 = data3b(1:num, :);
  data4 = data4b(1:num, :);
  data5 = data5b(1:num, :);
  data6 = data6b(1:num, :);
  data7 = data7b(1:num, :);
  data8 = data8b(1:num, :);
  data9 = data9b(1:num, :);
  
  data10 = data10b(1:num, :);
  data11 = data11b(1:num, :);
  data12 = data12b(1:num, :);
  data13 = data13b(1:num, :);
  data14 = data14b(1:num, :);
  data15 = data15b(1:num, :);
  data16 = data16b(1:num, :);
  data17 = data17b(1:num, :);
  data18 = data18b(1:num, :);
  data19 = data19b(1:num, :);
  
  data20 = data20b(1:num, :);
  data21 = data21b(1:num, :);
  data22 = data22b(1:num, :);
  data23 = data23b(1:num, :);
  data24 = data24b(1:num, :);
  data25 = data25b(1:num, :);
  data26 = data26b(1:num, :);
  data27 = data27b(1:num, :);
  data28 = data28b(1:num, :);
  data29 = data29b(1:num, :);
 
  data30 = data30b(1:num, :);
  data31 = data31b(1:num, :);
  data32 = data32b(1:num, :);
  data33 = data33b(1:num, :);
  data34 = data34b(1:num, :);
  data35 = data35b(1:num, :);
  data36 = data36b(1:num, :);
  data37 = data37b(1:num, :);
  data38 = data38b(1:num, :);
  data39 = data39b(1:num, :);
 
  data40 = data40b(1:num, :);
  data41 = data41b(1:num, :);
  data42 = data42b(1:num, :);
  data43 = data43b(1:num, :);
  data44 = data44b(1:num, :);
  data45 = data45b(1:3*num, :);
  data46 = data46b(1:2*num, :);
  data47 = data47b(1:num, :);
  data49 = data49b(1:num, :);
  
  data50 = data50b(1:num, :);
  data51 = data51b(1:num, :);
  data52 = data52b(1:num, :);
  data53 = data53b(1:2*num, :);
  data54 = data54b(1:num, :);
  data55 = data55b(1:num, :);
  data56 = data56b(:, :);
  data57 = data57b(1:3*num, :);
  data58 = data58b(1:3*num, :);
  data59 = data59b(1:num, :);
  
  data60 = data60b( :, :);
  data61 = data61b( :, :);
  %data62 = data62b(1:num, :);

  data63 = data63b(:, :);
  data64 = data64b(1:2*num, :);
  data65 = data65b( 1:num , :);
  data66 = data66b( 1:num, :);
  data67 = data67b( :, :);
  data68 = data68b( :, :);
  
  

  
  %data = [data0; data1; data2; data3; data4; data5; data6; data7; data8; ...
  %        data9; data10; data11; data12; data13; data14; data15; data16; ...
  %        data17; data18; data19; data20; data21; data22; data23; data24;...
  %        data25; data26; data27; data28; data29; data30; data31; data32; ...
  %        data33; data34; data35; data36; data37; data38; data39; data40; ...
  %        data41; data42;  data43; data44; data45; data46; data47; ...
  %        data49; data50; data51; data52; data53; data54; data55; data56; ...
  %        data57; data58; data59; data60; data61; data63; data64; data65; ...
  %        data66; data67; data68; ];
 
  data = [data0; data1; data2; data3; data4; data5; data6; data7; data8; ...
          data9; data10; data11; data12; data13; data14; data15; data16; ...
          data17; data18; data19; data20; data21; data22; data23; data24;...
          data25; data26; data27; data28; data29; data30; data31; data32; ...
          data33; data34; data35; data36; data37; data38; data39; data40; ...
          data41; data42;  data43; data44; data45; data46; data47; ...
          data49; data50; data51; data52; data53; data54; data55;  ...
          data57; data58; data61; data63; data64; data65; ...
          data66; ];
  
  
  disp('Ndata is:');
  disp(size(data,1))
   
   

end


function ExportParameters(params)

b0000 = params(1);
b0001 = params(2);
b0002 = params(3);
b0003 = params(4);
b0004 = params(5);
b0101 = params(6);
b0102 = params(7);
b0103 = params(8);
b0201 = params(9);
b1000 = params(10);
b1001 = params(11);
b1002 = params(12);
b1003 = params(13);
b1100 = params(14);
b1101 = params(15);
b1102 = params(16);
b1200 = params(17);
b1201 = params(18);
b2000 = params(19);
b2001 = params(20);
b2002 = params(21);
b2100 = params(22);
b2101 = params(23);
b2200 = params(24);
b3000 = params(25);
b3001 = params(26);
b3100 = params(27);
b0011 = params(28);
b0012 = params(29);
b0013 = params(30);
b0110 = params(31);
b0111 = params(32);
b0112 = params(33);
b0210 = params(34);
b0211 = params(35);
b1010 = params(36);
b1011 = params(37);
b1012 = params(38);
b1110 = params(39);
b1111 = params(40);
b1210 = params(41);
b2010 = params(42);
b2011 = params(43);
b2110 = params(44);
b3010 = params(45);
b0020 = params(46);
b0021 = params(47);
b0022 = params(48);
b0121 = params(49);
b0220 = params(50);
b1020 = params(51);
b1021 = params(52);
b2020 = params(53);
b0030 = params(54);
b0031 = params(55);
b0130 = params(56);
b1030 = params(57);
b0040 = params(58);
b1103 = params(59);
b2103 = params(60);
b2201 = params(61);
b3101 = params(62);
b3201 = params(63);
b4001 = params(64);
b4101 = params(65);
b5001 = params(66);
b3020 = params(67);
b4020 = params(68);
 


  
  
  
  
 matrix=[
   [000, b0000, b1000, b2000, b3000, 0.000, 0.000 ];
   [100, 0.000, b1100, b2100, b3100, 0.000, 0.000 ];   
   [200, 0.000, b1200, b2200, 0.000, 0.000, 0.000 ];   
   [010, 0.000, b1010, b2010, b3010, 0.000, 0.000 ];   
   [020, b0020, b1020, b2020, b3020, b4020, 0.000 ];   
   [030, b0030, b1030, 0.000, 0.000, 0.000, 0.000 ];   
   [040, b0040, 0.000, 0.000, 0.000, 0.000, 0.000 ]; 
   [001, b0001, b1001, b2001, b3001, b4001, b5001 ];   
   [002, b0002, b1002, b2002, 0.000, 0.000, 0.000 ];   
   [003, b0003, b1003, 0.000, 0.000, 0.000, 0.000 ];   
   [004, b0004, 0.000, 0.000, 0.000, 0.000, 0.000 ];
   [011, b0011, b1011, b2011, 0.000, 0.000, 0.000 ];   
   [021, b0021, b1021, 0.000, 0.000, 0.000, 0.000 ];   
   [031, b0031, 0.000, 0.000, 0.000, 0.000, 0.000 ];   
   [012, b0012, b1012, 0.000, 0.000, 0.000, 0.000 ];   
   [022, b0022, 0.000, 0.000, 0.000, 0.000, 0.000 ];   
   [013, b0013, 0.000, 0.000, 0.000, 0.000, 0.000 ];   
   [101, b0101, b1101, b2101, b3101, b4101, 0.000 ];   
   [201, b0201, b1201, b2201, b3201, 0.000, 0.000 ];   
   [102, b0102, b1102, 0.000, 0.000, 0.000, 0.000 ];   
   [103, b0103, b1103, b2103, 0.000, 0.000, 0.000 ];
   [110, b0110, b1110, b2110, 0.000, 0.000, 0.000 ];   
   [210, b0210, b1210, 0.000, 0.000, 0.000, 0.000 ];   
   [220, b0220, 0.000, 0.000, 0.000, 0.000, 0.000 ];   
   [130, b0130, 0.000, 0.000, 0.000, 0.000, 0.000 ];
   [111, b0111, b1111, 0.000, 0.000, 0.000, 0.000 ];   
   [112, b0112, 0.000, 0.000, 0.000, 0.000, 0.000 ];  
   [211, b0211, 0.000, 0.000, 0.000, 0.000, 0.000 ];   
   [121, b0121, 0.000, 0.000, 0.000, 0.000, 0.000 ];
   ]
 

 
   dlmwrite('ParameterResultsPhiMatlabMatrixSVD.dat',matrix, ' ');
 
  
   
  
  
  out = [ b0000, b0001, b0002, b0003, b0004, b0011, b0012, b0013, b0020, ... 
          b0021, b0022, b0030, b0031, b0040, b0101, b0102, b0103, b0110, ...
          b0111, b0112, b0121, b0130, b0201, b0210, b0211, b0220, b1000, ...
          b1001, b1002, b1003, b1010, b1011, b1012, b1020, b1021, b1030, ...
          b1100, b1101, b1102, b1110, b1111, b1200, b1201, b1210, b2000, ...
          b2001, b2002, b2010, b2011, b2020, b2100, b2101, b2110, b2200, ...
          b3000, b3001, b3010, b3100, b4001, b5001, b3101, b4101, b2201, ...
          b3201, b1103, b2103, b3020, b4020];
      
  dlmwrite('ParameterResultsPhiMatlabSVD.dat',out, ' ');
  
end

function CalculateLimits(params)
    x = 0.71; % maximum valie of FPx
    y = 0.18;
    th = 0.4;
    ph = 0.4
    fun = transpose([  1, ph, ph^2, ph^3, ph^4, ph*th, ph^2*th, ph^3*th, ...
          ph*th^2, x, ph*x, ph^2*x, ph^3*x, th*x, ph*th*x, ph^2*th*x, ...
          th^2*x, ph*th^2*x, x^2, ph*x^2, ph^2*x^2, th*x^2, ph*th*x^2, ...
          th^2*x^2, x^3, ph*x^3, th*x^3, ph*y, ph^2*y, ph^3*y, th*y, ...
          ph*th*y, ph^2*th*y, th^2*y, ph*th^2*y, x*y, ph*x*y, ph^2*x*y, ...
          th*x*y, ph*th*x*y, th^2*x*y, x^2*y, ph*x^2*y, th*x^2*y, x^3*y, ...
          y^2, ph*y^2, ph^2*y^2, ph*th*y^2, th^2*y^2, x*y^2, ph*x*y^2, ...
          x^2*y^2, y^3, ph*y^3, th*y^3, x*y^3, y^4, ph^3*th*x, ...
          ph^3*th*x^2, ph*th^2*x^2, ph*th*x^3, ph*th^2*x^3, ph*x^4, ...
          ph*th*x^4, ph*x^5, x^3*y^2, x^4*y^2 ]);
         
   val = params.*fun;
   disp('Limits:');
   disp(val);
   dlmwrite('TgPhSVDLimits.dat',val, ' ');
end
